use shiny_arena::make_comb;

use crate::ptr;

make_comb! {
    /// Product type pattern.
    pub struct Prod {
        pub lhs: ptr::Pat,
        pub rhs: ptr::Pat,
    }

    /// Sum type pattern.
    pub struct Sum {
        pub lhs: ptr::Pat,
        pub rhs: ptr::Pat,
    }

    /// Exact type. Matches only if matched type
    /// equals to specified.
    pub struct ExactTy(pub ptr::Ty);

    /// Field type. matches `{ name : ty_pat }`
    pub struct Field {
        pub name: ptr::Id,
        pub ty: ptr::Pat,
    }

    /// "Value" pattern. Works like [`ExactTy`], but
    /// additionally checks whether value of that type is equal
    /// to specified value.
    pub struct Value(pub ptr::Value);
}
